#pragma once

#include "UIListCommonDefine.hpp"
#include "ChatUser.h"
#include <list>

namespace DuiLib
{
struct ChatListItemInfo
{
	bool empty;
	GTUserStatusType  status;
	CDuiString id;
	CDuiString logo;
	CDuiString nick_name;
	CDuiString description;
    ChatListItemInfo()
    {
        empty = false;
        status = ustOFFLINE;
    }
};


class CChatLeftList : public CListUI
{
public:
	enum {SCROLL_TIMERID = 10};

	CChatLeftList(CPaintManagerUI& paint_manager);

	~CChatLeftList();

	bool Add(CControlUI* pControl);

	bool AddAt(CControlUI* pControl, int iIndex);

	bool Remove(CControlUI* pControl);

	bool RemoveAt(int iIndex);

	void RemoveAll();

	void DoEvent(TEventUI& event);

	Node* GetRoot();

	void UpdateNode(Node* node, CString strImage);

	Node* AddNode(const ChatListItemInfo& item, int nCompareData=0, Node* parent = NULL);

	void UpdateTooltip(CChatUser* pChatUser);
	void UpdateName(CChatUser* pChatUser);


	void UpdateStatus(CChatUser* pChatUser, GTUserStatusType stStatus);

	void CChatLeftList::ResortChatList();

	bool RemoveNode(Node* node);

	bool RemoveNodeByUserID(LPCTSTR strUserID);

	void SetChildVisible(Node* node, bool visible);

	bool CanExpand(Node* node) const;

	/*bool SelectItem(int iIndex, bool bTakeFocus = false);

	bool SelectItems(int iIndex, bool bTakeFocus = false);
	bool SelectItemSingle(int iIndex, bool bTakeFocus = false);
	bool UnSelectItemSingle(int iIndex, bool bTakeFocus = false);*/
	list<Node*> GetSelectedItems();
	void SetEnableScroll(BOOL bEnable);
	void SetSelectViewModal( CControlUI* pControl, bool bSelect);
	static int CALLBACK CChatLeftList::chatUsrSortFunc(void* pElem1,void* pElem2);
	Node* FindNodeByUserID(LPCTSTR strUserID);
public:
	CPaintManagerUI& paint_manager_;
private:
	BOOL	m_bEnableScroll;
	Node*	root_node_;
	LONG	delay_deltaY_;
	DWORD	delay_number_;
	DWORD	delay_left_;
	CDuiRect	text_padding_;
	int level_text_start_pos_;
	CDuiString level_expand_image_;
	CDuiString level_collapse_image_;

    CDialogBuilder m_dlgBuilder;
};

} // DuiLib
